Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/molecules.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -1898,5 +1898,5 @@
     return false;
   }
-  cout << Verbose(1) << "Parsing the KeySet file ... ";
+  cout << Verbose(1) << "Parsing the KeySet file ... " << endl;
   // open file and read
   sprintf(filename, "%s/%s%s", path, FRAGMENTPREFIX, KEYSETFILE);
@@ -1942,5 +1942,5 @@
  * \return true - file written successfully, false - writing failed
  */
-bool molecule::StoreAdjacencyToFile(ofstream *out, char *path, int bondorder)
+bool molecule::StoreAdjacencyToFile(ofstream *out, char *path)
 {
   ofstream AdjacencyFile;
@@ -1953,5 +1953,4 @@
   cout << Verbose(1) << "Saving adjacency list ... ";
   if (AdjacencyFile != NULL) {
-    AdjacencyFile << "Order\t" << bondorder << endl;
     Walker = start;
     while(Walker->next != end) {
@@ -1977,8 +1976,7 @@
  * \param *path path to file
  * \param **ListOfAtoms allocated (molecule::AtomCount) and filled lookup table for ids (Atom::nr) to *Atom
- * \param bondorder check whether files matches desired bond order
  * \return true - structure is equal, false - not equivalence
  */ 
-bool molecule::CheckAdjacencyFileAgainstMolecule(ofstream *out, char *path, atom **ListOfAtoms, int bondorder)
+bool molecule::CheckAdjacencyFileAgainstMolecule(ofstream *out, char *path, atom **ListOfAtoms)
 {
   char *filename = (char *) Malloc(sizeof(char)*MAXSTRINGSIZE, "molecule::CheckAdjacencyFileAgainstMolecule - filename");
@@ -1995,53 +1993,46 @@
     int CurrentBondsOfAtom;
 
-    // determine order from file
-    File.getline(filename, MAXSTRINGSIZE);    
-    if (bondorder != atoi(&filename[5])) {
-      *out << "Bond order desired is " << bondorder << " and does not match one in file " << filename[6] << "." << endl;
-      status = false;
-    } else {
-      // Parse the file line by line and count the bonds
-      while (!File.eof()) {
-        File.getline(filename, MAXSTRINGSIZE);
-        stringstream line;
-        line.str(filename);
-        int AtomNr = -1;
-        line >> AtomNr;
-        CurrentBondsOfAtom = -1; // we count one too far due to line end
-        // parse into structure
-        if ((AtomNr >= 0) && (AtomNr < AtomCount)) {
-          while (!line.eof())
-            line >> CurrentBonds[ ++CurrentBondsOfAtom ];
-          // compare against present bonds
-          //cout << Verbose(2) << "Walker is " << *Walker << ", bond partners: ";
-          if (CurrentBondsOfAtom == NumberOfBondsPerAtom[AtomNr]) {
-            for(int i=0;i<NumberOfBondsPerAtom[AtomNr];i++) {
-              int id = ListOfBondsPerAtom[AtomNr][i]->GetOtherAtom(ListOfAtoms[AtomNr])->nr;
-              int j = 0;
-              for (;(j<CurrentBondsOfAtom) && (CurrentBonds[j++] != id);); // check against all parsed bonds
-              if (CurrentBonds[j-1] != id) { // no match ? Then mark in ListOfAtoms
-                ListOfAtoms[AtomNr] = NULL;
-                NonMatchNumber++;
-                status = false;
-                //out << "[" << id << "]\t";
-              } else {
-                //out << id << "\t";
-              }
+    // Parse the file line by line and count the bonds
+    while (!File.eof()) {
+      File.getline(filename, MAXSTRINGSIZE);
+      stringstream line;
+      line.str(filename);
+      int AtomNr = -1;
+      line >> AtomNr;
+      CurrentBondsOfAtom = -1; // we count one too far due to line end
+      // parse into structure
+      if ((AtomNr >= 0) && (AtomNr < AtomCount)) {
+        while (!line.eof())
+          line >> CurrentBonds[ ++CurrentBondsOfAtom ];
+        // compare against present bonds
+        //cout << Verbose(2) << "Walker is " << *Walker << ", bond partners: ";
+        if (CurrentBondsOfAtom == NumberOfBondsPerAtom[AtomNr]) {
+          for(int i=0;i<NumberOfBondsPerAtom[AtomNr];i++) {
+            int id = ListOfBondsPerAtom[AtomNr][i]->GetOtherAtom(ListOfAtoms[AtomNr])->nr;
+            int j = 0;
+            for (;(j<CurrentBondsOfAtom) && (CurrentBonds[j++] != id);); // check against all parsed bonds
+            if (CurrentBonds[j-1] != id) { // no match ? Then mark in ListOfAtoms
+              ListOfAtoms[AtomNr] = NULL;
+              NonMatchNumber++;
+              status = false;
+              //out << "[" << id << "]\t";
+            } else {
+              //out << id << "\t";
             }
-            //out << endl;
-          } else {
-            *out << "Number of bonds for Atom " << *ListOfAtoms[AtomNr] << " does not match, parsed " << CurrentBondsOfAtom << " against " << NumberOfBondsPerAtom[AtomNr] << "." << endl;
-            status = false;
           }
+          //out << endl;
+        } else {
+          *out << "Number of bonds for Atom " << *ListOfAtoms[AtomNr] << " does not match, parsed " << CurrentBondsOfAtom << " against " << NumberOfBondsPerAtom[AtomNr] << "." << endl;
+          status = false;
         }
       }
-      File.close();
-      File.clear();
-      if (status) { // if equal we parse the KeySetFile
-        *out << " done: Equal." << endl;
-        status = true;
-      } else
-        *out << " done: Not equal by " << NonMatchNumber << " atoms." << endl;
-    }
+    }
+    File.close();
+    File.clear();
+    if (status) { // if equal we parse the KeySetFile
+      *out << " done: Equal." << endl;
+      status = true;
+    } else
+      *out << " done: Not equal by " << NonMatchNumber << " atoms." << endl;
     Free((void **)&CurrentBonds, "molecule::CheckAdjacencyFileAgainstMolecule - **CurrentBonds");
   } else {
@@ -2057,11 +2048,8 @@
  * Writes for each fragment a config file.
  * \param *out output stream for debugging
- * \param BottomUpOrder up to how many neighbouring bonds a fragment contains in BondOrderScheme::BottumUp scheme
- * \param TopDownOrder up to how many neighbouring bonds a fragment contains in BondOrderScheme::TopDown scheme
- * \param Scheme which BondOrderScheme to use for the fragmentation
+ * \param Order up to how many neighbouring bonds a fragment contains in BondOrderScheme::BottumUp scheme
  * \param *configuration configuration for writing config files for each fragment
- * \param CutCyclic whether to add cut cyclic bond or to saturate
- */
-void molecule::FragmentMolecule(ofstream *out, int BottomUpOrder, int TopDownOrder, enum BondOrderScheme Scheme, config *configuration, enum CutCyclicBond CutCyclic)
+ */
+void molecule::FragmentMolecule(ofstream *out, int Order, config *configuration)
 {
 	MoleculeListClass **BondFragments = NULL;
@@ -2072,16 +2060,16 @@
   int AtomNo;
   int MinimumRingSize;
-  int TotalFragmentCounter = 0;
-  int FragmentCounter = 0;
+  int TotalFragmentCounter;
+  int FragmentCounter;
   MoleculeLeafClass *MolecularWalker = NULL;
   MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
   fstream File;
-  bool status = true;
-
-  cout << endl;
+  bool FragmentationToDo = true;
+
+  *out << endl;
 #ifdef ADDHYDROGEN
-  cout << Verbose(0) << "I will treat hydrogen special and saturate dangling bonds with it." << endl;
+  *out << Verbose(0) << "I will treat hydrogen special and saturate dangling bonds with it." << endl;
 #else
-  cout << Verbose(0) << "Hydrogen is treated just like the rest of the lot." << endl;
+  *out << Verbose(0) << "Hydrogen is treated just like the rest of the lot." << endl;
 #endif
 
@@ -2101,35 +2089,45 @@
   if (Walker->next != end) {  // everything went alright
     *out << " range of nuclear ids exceeded [0, AtomCount)." << endl;
-    status = false;
-  }
-  status = status && CheckAdjacencyFileAgainstMolecule(out, configuration->configpath, ListOfAtoms, BottomUpOrder); 
-  if (status) {  // NULL entries in ListOfAtoms contain NonMatches
-    status = status && ParseKeySetFile(out, configuration->configpath, ListOfAtoms, FragmentList, configuration->GetIsAngstroem());
-  }
+    FragmentationToDo = false;
+  }
+  FragmentationToDo = FragmentationToDo && CheckAdjacencyFileAgainstMolecule(out, configuration->configpath, ListOfAtoms); 
+  if (FragmentationToDo)  // NULL entries in ListOfAtoms contain NonMatches
+    FragmentationToDo = FragmentationToDo && ParseKeySetFile(out, configuration->configpath, ListOfAtoms, FragmentList, configuration->GetIsAngstroem());
+  if (FragmentationToDo)  // parse the adaptive order per atom/site/vertex
+    FragmentationToDo = FragmentationToDo && ParseOrderAtSiteFromFile(out, configuration->configpath);
   Free((void **)&ListOfAtoms, "molecule::FragmentMolecule - **ListOfAtoms");
 
   // =================================== Begin of FRAGMENTATION ===============================
-  if (!status) {
-    // === store Adjacency file ===
-    StoreAdjacencyToFile(out, configuration->configpath, BottomUpOrder);
-
+  if (FragmentationToDo) { // if we parsed Adjacancy, check whether OrderAtSite is above Order everywhere
+    Walker = start;
+    while (Walker->next != end) { // create a lookup table (Atom::nr -> atom) used as a marker table lateron 
+      Walker = Walker->next;
+#ifdef ADDHYDROGEN
+      if (Walker->type->Z != 1) // skip hydrogen
+#endif
+        if (Walker->AdaptiveOrder < Order)
+          FragmentationToDo = false;
+    }
+  } 
+  
+  if (!FragmentationToDo) { // if we have still do something, FragmentationToDo will be false
     // === first perform a DFS analysis to gather info on cyclic structure and a list of disconnected subgraphs ===
-    Subgraphs = DepthFirstSearchAnalysis((ofstream *)&cout, false, MinimumRingSize);
+    Subgraphs = DepthFirstSearchAnalysis((ofstream *)&*out, false, MinimumRingSize);
     MolecularWalker = Subgraphs;
     // fill the bond structure of the individually stored subgraphs
     while (MolecularWalker->next != NULL) {
       MolecularWalker = MolecularWalker->next;
-      cout << Verbose(1) << "Creating adjacency list for subgraph " << MolecularWalker << "." << endl;
-      MolecularWalker->Leaf->CreateAdjacencyList((ofstream *)&cout, BondDistance);
-      MolecularWalker->Leaf->CreateListOfBondsPerAtom((ofstream *)&cout);
+      *out << Verbose(1) << "Creating adjacency list for subgraph " << MolecularWalker << "." << endl;
+      MolecularWalker->Leaf->CreateAdjacencyList(out, BondDistance);
+      MolecularWalker->Leaf->CreateListOfBondsPerAtom(out);
     }
     
     // === fragment all subgraphs ===
-    if ((MinimumRingSize != -1) && ((BottomUpOrder >= MinimumRingSize) || (TopDownOrder >= MinimumRingSize))) {
-      cout << Verbose(0) << "Bond order greater than or equal to Minimum Ring size of " << MinimumRingSize << " found is not allowed." << endl;
+    if ((MinimumRingSize != -1) && (Order >= MinimumRingSize)) {
+      *out << Verbose(0) << "Bond order greater than or equal to Minimum Ring size of " << MinimumRingSize << " found is not allowed." << endl;
     } else {
       FragmentCounter = 0;
       MolecularWalker = Subgraphs;
-      // count subgraphs
+      // count subgraphs and allocate fragments
       while (MolecularWalker->next != NULL) {
         MolecularWalker = MolecularWalker->next;
@@ -2137,10 +2135,35 @@
       }
       BondFragments = (MoleculeListClass **) Malloc(sizeof(MoleculeListClass *)*FragmentCounter, "molecule::FragmentMolecule - **BondFragments");
+      
+      // create RootStack for each Subgraph 
+      // NOTE: (keep this extern of following while loop, as lateron we may here look for which site to add to which subgraph)
+      KeyStack RootStack[FragmentCounter];
+
+      FragmentCounter = 0;
+      MolecularWalker = Subgraphs;
+      // count subgraphs and allocate fragments
+      while (MolecularWalker->next != NULL) {
+        MolecularWalker = MolecularWalker->next;
+        RootStack[FragmentCounter].clear();  
+        // find first root candidates  
+        Walker = MolecularWalker->Leaf->start;
+        while (Walker->next != MolecularWalker->Leaf->end) { // go through all (non-hydrogen) atoms
+          Walker = Walker->next;
+      #ifdef ADDHYDROGEN
+          if (Walker->type->Z != 1) // skip hydrogen
+      #endif
+            if (Walker->GetTrueFather()->AdaptiveOrder < Order) // only if Order is still greater
+              RootStack[FragmentCounter].push_front(Walker->nr);
+        }
+        FragmentCounter++;
+      }
+      
       // fill the bond fragment list
       FragmentCounter = 0;
+      TotalFragmentCounter = 0;
       MolecularWalker = Subgraphs;
       while (MolecularWalker->next != NULL) {
         MolecularWalker = MolecularWalker->next;
-        cout << Verbose(1) << "Fragmenting subgraph " << MolecularWalker << "." << endl;
+        *out << Verbose(1) << "Fragmenting subgraph " << MolecularWalker << "." << endl;
         if (MolecularWalker->Leaf->first->next != MolecularWalker->Leaf->last) {
             // output ListOfBondsPerAtom for debugging
@@ -2165,38 +2188,22 @@
           *out << Verbose(0) << "Begin of bond fragmentation." << endl;
           BondFragments[FragmentCounter] = NULL;
-          if (Scheme == ANOVA) {
-            Graph *FragmentList = MolecularWalker->Leaf->FragmentBOSSANOVA(out,BottomUpOrder,configuration);
-
-            // allocate memory for the pointer array and transmorph graphs into full molecular fragments
-            int TotalNumberOfMolecules = 0;
-            for(Graph::iterator runner = FragmentList->begin(); runner != FragmentList->end(); runner++)
-              TotalNumberOfMolecules++;
-            BondFragments[FragmentCounter] = new MoleculeListClass(TotalNumberOfMolecules, AtomCount);
-            int k=0;
-            for(Graph::iterator runner = FragmentList->begin(); runner != FragmentList->end(); runner++) {
-              KeySet test = (*runner).first;
-              BondFragments[FragmentCounter]->ListOfMolecules[k] = StoreFragmentFromKeySet(out, test, configuration);
-              BondFragments[FragmentCounter]->TEList[k] = ((*runner).second).second;
-              k++;
-            }
-          }  
-          if ((Scheme == BottomUp) || (Scheme == Combined)) { // get overlapping subgraphs
-            BondFragments[FragmentCounter] = FragmentList = MolecularWalker->Leaf->FragmentBottomUp(out, BottomUpOrder, configuration, CutCyclic);
+          // call BOSSANOVA method
+          Graph *FragmentList = MolecularWalker->Leaf->FragmentBOSSANOVA(out, RootStack[FragmentCounter]);
+
+          // allocate memory for the pointer array and transmorph graphs into full molecular fragments
+          int TotalNumberOfMolecules = 0;
+          for(Graph::iterator runner = FragmentList->begin(); runner != FragmentList->end(); runner++)
+            TotalNumberOfMolecules++;
+          BondFragments[FragmentCounter] = new MoleculeListClass(TotalNumberOfMolecules, AtomCount);
+          int k=0;
+          for(Graph::iterator runner = FragmentList->begin(); runner != FragmentList->end(); runner++) {
+            KeySet test = (*runner).first;
+            *out << "Fragment No." << (*runner).second.first << " was created " << (int)(*runner).second.second << " time(s)." << endl;
+            BondFragments[FragmentCounter]->ListOfMolecules[k] = MolecularWalker->Leaf->StoreFragmentFromKeySet(out, test, configuration);
+            k++;
           }
-          if (Scheme == TopDown) { // initialise top level with whole molecule
-            *out << Verbose(2) << "Initial memory allocating and initialising for whole molecule." << endl;
-            FragmentList = new MoleculeListClass(1, MolecularWalker->Leaf->AtomCount);
-            FragmentList->ListOfMolecules[0] = MolecularWalker->Leaf->CopyMolecule();
-            FragmentList->TEList[0] = 1.;
-          }
-          if ((Scheme == Combined) || (Scheme == TopDown)) {
-            *out << Verbose(1) << "Calling TopDown." << endl;
-            BondFragments[FragmentCounter] = FragmentList->FragmentTopDown(out, TopDownOrder, BondDistance, configuration, CutCyclic);
-            // remove this molecule from list again and free wrapper list
-            delete(FragmentList);
-            FragmentList = NULL;
-          }
+          *out << k << "/" << BondFragments[FragmentCounter]->NumberOfMolecules << " fragments generated from the keysets." << endl;
         } else {
-          cout << Verbose(0) << "Connection matrix has not yet been generated!" << endl;
+          *out << Verbose(0) << "Connection matrix has not yet been generated!" << endl;
         }
         TotalFragmentCounter += BondFragments[FragmentCounter]->NumberOfMolecules;
@@ -2212,5 +2219,5 @@
         FragmentList->ListOfMolecules[TotalFragmentCounter] =  BondFragments[i]->ListOfMolecules[j];
         BondFragments[i]->ListOfMolecules[j] = NULL;
-        FragmentList->TEList[TotalFragmentCounter++] = BondFragments[i]->TEList[j];
+        TotalFragmentCounter++;
       }
       delete(BondFragments[i]);
@@ -2218,5 +2225,5 @@
     Free((void **)&BondFragments, "molecule::FragmentMolecule - **BondFragments");
   } else
-    cout << Verbose(0) << "Using fragments reconstructed from the KeySetFile." << endl;
+    *out << Verbose(0) << "Nothing to do, using only fragments reconstructed from the KeySetFile." << endl;
   // ==================================== End of FRAGMENTATION ================================
   
@@ -2241,9 +2248,15 @@
     }
     *out << Verbose(1) << "Writing " << FragmentList->NumberOfMolecules << " possible bond fragmentation configs" << endl;
-    if (FragmentList->OutputConfigForListOfFragments("BondFragment", configuration, SortIndex))
+    if (FragmentList->OutputConfigForListOfFragments(out, configuration, SortIndex))
       *out << Verbose(1) << "All configs written." << endl;
     else
       *out << Verbose(1) << "Some configs' writing failed." << endl;
     Free((void **)&SortIndex, "molecule::FragmentMolecule: *SortIndex"); 
+    
+    // === store Adjacency file ===
+    StoreAdjacencyToFile(out, configuration->configpath);
+
+    // Store adaptive orders into file
+    StoreOrderAtSiteFile(out, configuration->configpath);
     
     // restore orbital and Stop values
@@ -2256,4 +2269,5 @@
   } else
     *out << Verbose(1) << "FragmentList is zero on return, splitting failed." << endl;
+  
   // free subgraph memory again
   if (Subgraphs != NULL) {
@@ -2266,4 +2280,79 @@
 
   *out << Verbose(0) << "End of bond fragmentation." << endl;
+};
+
+/** Stores pairs (Atom::nr, Atom::AdaptiveOrder) into file.
+ * Atoms not present in the file get "-1".
+ * \param *out output stream for debugging
+ * \param *path path to file ORDERATSITEFILE
+ * \return true - file writable, false - not writable
+ */
+bool molecule::StoreOrderAtSiteFile(ofstream *out, char *path)
+{
+  stringstream line;
+  ofstream file;
+
+  line << path << "/" << FRAGMENTPREFIX << ORDERATSITEFILE;
+  file.open(line.str().c_str());
+  *out << Verbose(0) << "Writing OrderAtSite " << ORDERATSITEFILE << " ... " << endl;
+  if (file != NULL) {
+    atom *Walker = start;
+    while (Walker->next != end) {
+      Walker = Walker->next;
+      file << Walker->nr << "\t" << (int)Walker->AdaptiveOrder << endl;
+      *out << Verbose(2) << "Storing: " << Walker->nr << "\t" << (int)Walker->AdaptiveOrder << "." << endl;
+    }
+    file.close();
+    return true;
+  } else {
+    return false;
+  }
+};
+
+/** Parses pairs(Atom::nr, Atom::AdaptiveOrder) from file and stores in molecule's Atom's.
+ * Atoms not present in the file get "0".
+ * \param *out output stream for debugging
+ * \param *path path to file ORDERATSITEFILEe
+ * \return true - file found and scanned, false - file not found
+ * \sa ParseKeySetFile() and CheckAdjacencyFileAgainstMolecule() as this is meant to be used in conjunction with the two
+ */
+bool molecule::ParseOrderAtSiteFromFile(ofstream *out, char *path)
+{
+  unsigned char *OrderArray = (unsigned char *) Malloc(sizeof(unsigned char)*AtomCount, "molecule::ParseOrderAtSiteFromFile - *OrderArray");
+  bool status;
+  int AtomNr;
+  stringstream line;
+  ifstream file;
+  int Order;
+
+  *out << Verbose(1) << "Begin of ParseOrderAtSiteFromFile" << endl;
+  for(int i=0;i<AtomCount;i++)
+    OrderArray[i] = 0;
+  line << path << "/" << FRAGMENTPREFIX << ORDERATSITEFILE;
+  file.open(line.str().c_str());
+  if (file != NULL) {
+    for (int i=0;i<AtomCount;i++) // initialise with 0
+      OrderArray[i] = 0;
+    while (!file.eof()) { // parse from file
+      file >> AtomNr;
+      file >> Order;
+      OrderArray[AtomNr] = (unsigned char) Order;
+      //*out << Verbose(2) << "AtomNr " << AtomNr << " with order " << (int)OrderArray[AtomNr] << "." << endl;
+    }
+    atom *Walker = start;
+    while (Walker->next != end) { // fill into atom classes
+      Walker = Walker->next;
+      Walker->AdaptiveOrder = OrderArray[Walker->nr];
+      *out << Verbose(2) << *Walker << " gets order " << (int)Walker->AdaptiveOrder << "." << endl; 
+    }
+    file.close();
+    status = true;
+  } else {
+    status = false;
+  }
+  Free((void **)&OrderArray, "molecule::ParseOrderAtSiteFromFile - *OrderArray");
+  
+  *out << Verbose(1) << "End of ParseOrderAtSiteFromFile" << endl;
+  return status;
 };
 
